void BothQuestComplete(string sQuestName)
{
	ref PChar, sld;
	int iPassenger;
	PChar = GetMainCharacter();
	string homelocation, homegroup, homelocator, tavernfriend;

	switch(sQuestName)
	{

///////////////////////////////////////////////////////////////
///// SAVING TOFF'S DAUGHTER
///////////////////////////////////////////////////////////////


		case "to_ship_of_Bernardo_Gamboa":
			LAi_SetActorType(pchar);
			pchar.dialog.currentnode = "to_ship_of_Bernardo_Gamboa";
			LAi_ActorSelfDialog(pchar, "player_back");
		break;

		case "not_to_the_ship":
			LAi_SetPlayerType(pchar);
			pchar.quest.not_to_the_ship_2.win_condition.l1 = "ExitFromLocation";
			pchar.quest.not_to_the_ship_2.win_condition.l1.location = "Douwesen_port";
			pchar.quest.not_to_the_ship_2.win_condition = "not_to_the_ship_2";
		break;

		case "not_to_the_ship_2":
			pchar.quest.to_ship_of_Bernardo_Gamboa.win_condition.l1 = "location";
			pchar.quest.to_ship_of_Bernardo_Gamboa.win_condition.l1.location = "douwesen_port";
			pchar.quest.to_ship_of_Bernardo_Gamboa.win_condition = "to_ship_of_Bernardo_Gamboa";
		break;

		case "to_the_ship":
			DoQuestReloadToLocation("Gamboa_ship", "reload", "locator2", "to_the_ship_2");
		break;

		case "to_the_ship_2":
			LAi_SetActorType(pchar);
// KK -->
			if (!CharacterIsDead(characterFromID("Bernardo Gamboa"))) {
				LAi_SetActorType(characterFromID("Bernardo Gamboa"));
				LAi_ActorFollow(pchar, characterFromID("Bernardo Gamboa"), "", 1.5);
				LAi_ActorFollow(characterFromID("Bernardo Gamboa"), pchar, "to_the_ship_3", 1.5);
			} else {
				LAi_SetActorType(characterFromID("Corentin Lucay"));
				LAi_ActorFollow(pchar, characterFromID("Corentin Lucay"), "", 1.5);
				LAi_ActorFollow(characterFromID("Corentin Lucay"), pchar, "to_the_ship_3", 1.5);
			}
// <-- KK
		break;
		
		case "to_the_ship_3":
			LAi_type_actor_Reset(pchar);
// KK -->
			if (!CharacterIsDead(characterFromID("Bernardo Gamboa"))) {			
				LAi_ActorWaitDialog(pchar, characterFromID("Bernardo Gamboa"));
				LAi_ActorDialog(characterFromID("Bernardo Gamboa"), pchar, "", 2.0, 1.0);
			} else {
				LAi_ActorWaitDialog(pchar, characterFromID("Corentin Lucay"));
				LAi_ActorDialog(characterFromID("Corentin Lucay"), pchar, "", 2.0, 1.0);
			}
// <-- KK
		break;

		case "from_the_ship":
			DoQuestReloadToLocation("Douwesen_port", "reload", "reload2", "not_to_the_ship");
		break;

		case "back_to_the_port":
			DoQuestReloadToLocation("Douwesen_port", "reload", "reload2", "player_back");
		break;

		case "bad_fight_in_ship":
// KK -->
			PChar.quest.BlazeKilledFightingWithGamboa.win_condition.l1 = "NPC_Death";
			PChar.quest.BlazeKilledFightingWithGamboa.win_condition.l1.character = PChar.id;
			PChar.quest.BlazeKilledFightingWithGamboa.win_condition = "BlazeKilledFightingWithGamboa";
// <-- KK
			LAi_SetPlayerType(pchar);
			LAi_group_MoveCharacter(characterFromID("Bernardo Gamboa"), "PIRATES_ON_GAMBOA_SHIP");
			LAi_group_MoveCharacter(characterFromID("Corentin Lucay"), "PIRATES_ON_GAMBOA_SHIP");
			LAi_group_FightGroups("PIRATES_ON_GAMBOA_SHIP", LAI_GROUP_PLAYER, true);
			LAi_group_SetCheck("PIRATES_ON_GAMBOA_SHIP", "kill_him_all_in_gamboa_ship_complete");
		break;

// KK -->
		case "BlazeKilledFightingWithGamboa":
			pchar.quest.to_ship_of_Bernardo_Gamboa.win_condition.l1 = "location";
			pchar.quest.to_ship_of_Bernardo_Gamboa.win_condition.l1.location = "douwesen_port";
			pchar.quest.to_ship_of_Bernardo_Gamboa.win_condition = "to_ship_of_Bernardo_Gamboa";
			LAi_group_RemoveCheck("PIRATES_ON_GAMBOA_SHIP");
			if (CharacterIsDead(characterFromID("Bernardo Gamboa"))) {
				ChangeCharacterAddressGroup(characterFromID("Corentin Lucay"), "Gamboa_ship", "goto", "goto4");
				characters[GetCharacterIndex("Corentin Lucay")].Dialog.Filename = "Bernardo Gamboa_dialog.c";
				characters[GetCharacterIndex("Corentin Lucay")].Dialog.CurrentNode = "you_again";
			} else {
				LAi_group_MoveCharacter(characterFromID("Bernardo Gamboa"), "QC_CITIZENS");
				characters[GetCharacterIndex("Bernardo Gamboa")].Dialog.CurrentNode = "you_again";
			}
			if (!CharacterIsDead(characterFromID("Corentin Lucay"))) LAi_group_MoveCharacter(characterFromID("Corentin Lucay"), "QC_CITIZENS");
			characters[GetCharacterIndex("Toff Oremans")].quest.daughter = "help_begin";
		break;
// <-- KK

		case "kill_him_all_in_gamboa_ship_complete":
			LAi_QuestDelay("kill_him_all_in_gamboa_ship_2_complete", 2.0);
		break;

		case "kill_him_all_in_gamboa_ship_2_complete":
			AddQuestRecord("daughter", 3);
			LAi_SetActorType(pchar);
			pchar.dialog.currentnode = "Teneken_in_the_ship";
			LAi_ActorSelfDialog(pchar, "player_back");
		break;

		case "teneken_in_the_ship":
			LAi_fade("teneken_in_the_ship_2", "");
		break;

		case "teneken_in_the_ship_2":
			ChangeCharacterAddress(characterFromID("Tanneken Oremans"), "Gamboa_ship", "goto2");
			LAi_SetActorType(characterFromID("Tanneken Oremans"));
			LAi_SetActorType(pchar);
			LAi_ActorWaitDialog(pchar, characterFromID("Tanneken Oremans"));
			LAi_ActorDialog(characterFromID("Tanneken Oremans"), pchar, "player_back", 2.0, 1.0);
		break;

		case "talk_in_gamboa_ship":
			LAi_Type_Actor_Reset(pchar);
			LAi_ActorWaitDialog(pchar, characterFromID("Corentin Lucay"));
			LAi_SetActorType(characterFromID("Corentin Lucay"));
			LAi_ActorDialog(characterFromID("Corentin Lucay"), pchar, "", 2.0, 1.0);
		break;

		case "second_talk_in_gamboa_ship":
			LAi_Type_Actor_Reset(pchar);
			LAi_ActorWaitDialog(pchar, characterFromID("Bernardo Gamboa"));
			LAi_ActorDialog(characterFromID("Bernardo Gamboa"), pchar, "", 2.0, 1.0);
		break;

		case "gamboa_died":
			LAi_SetPlayerType(pchar);
			LAi_group_MoveCharacter(characterFromID("Bernardo Gamboa"), "PIRATES_ON_GAMBOA_SHIP");
			LAi_group_MoveCharacter(characterFromID("Corentin Lucay"), LAI_GROUP_PLAYER);
			LAi_group_FightGroups("PIRATES_ON_GAMBOA_SHIP", LAI_GROUP_PLAYER, true);
			LAi_group_SetCheck("PIRATES_ON_GAMBOA_SHIP", "gamboa_died_complete");
		break;

		case "gamboa_died_complete":
			LAi_QuestDelay("gamboa_died_2_complete", 1.0);
		break;

		case "gamboa_died_2_complete":
			if (!LAi_isDead(characterFromID("Corentin Lucay")))
			{
				characters[GetCharacterIndex("Corentin Lucay")].dialog.currentnode = "three";
				LAi_SetActorType(characterFromID("Corentin Lucay"));
				LAi_SetActorType(pchar);
				LAi_ActorWaitDialog(pchar, characterFromID("Corentin Lucay"));
				LAi_ActorDialog(characterFromID("Corentin Lucay"), pchar, "player_back", 2.0, 1.0);
				AddQuestRecord("daughter", 4);
			}
			else
			{
				LAi_QuestDelay("teneken_in_the_ship", 1.0);
			}
		break;


///////////////////////////////////////////////////////////////
///// RYS BLOOM QUEST
///////////////////////////////////////////////////////////////


		case "rys_becomes_officer":
			PlayerLostMoney(characterFromID("Rys Bloom"), 500);//MAXIMUS: new function located in Dialog_func.c
			characters[getCharacterIndex("Rys bloom")].quest.officertype = OFFIC_TYPE_FIRSTMATE;//MAXIMUS
			AddPassenger(Pchar, characterFromID("Rys Bloom"), 0);
			LAi_SetOfficerType(characterFromID("Rys Bloom"));
			characters[getCharacterIndex("Rys bloom")].location = "none";
			characters[GetCharacterIndex("Rys Bloom")].Dialog.Filename = "Enc_Officer_dialog.c"; // KK
			characters[GetCharacterIndex("Rys Bloom")].Dialog.CurrentNode = "Hired"; // KK
		break;


///////////////////////////////////////////////////////////////
///// BALDEWYN COFFIER & ARNAUD MATTON
///////////////////////////////////////////////////////////////


		case "hire_baldewyn":
			LAi_Fade("", "hire_baldewyn_2");
		break;
		
		case "hire_baldewyn_2":
			ChangeCharacterAddress(characterFromID("Baldewyn Coffier"), "none", "");
		break;
		
		case "baldewyn_wait_month":
			//characters[GetCharacterIndex("Baldewyn Coffier")].quest.hire = "wait_month";
			if (characters[GetCharacterIndex("Baldewyn Coffier")].quest.arno == "accepted") //Fix:Storekeeper:19.09
			{
				characters[GetCharacterIndex("Baldewyn Coffier")].quest.hire = "money_2";
			}
			else
			{
				characters[GetCharacterIndex("Baldewyn Coffier")].quest.hire = "wait_month";
			}
			PChar.quest.baldewyn_wait_month_timer.win_condition.l1 = "Timer";
			PChar.quest.baldewyn_wait_month_timer.win_condition.l1.date.day = GetAddingDataDay(0, 1, 0);
			PChar.quest.baldewyn_wait_month_timer.win_condition.l1.date.month = GetAddingDataMonth(0, 1, 0);
			PChar.quest.baldewyn_wait_month_timer.win_condition.l1.date.year = GetAddingDataYear(0, 1, 0);
			PChar.quest.baldewyn_wait_month_timer.win_condition = "baldewyn_wait_month_timer_complete";
		break;
		
		case "baldewyn_wait_month_timer_complete":
			characters[GetCharacterIndex("Baldewyn Coffier")].quest.hire =  "money_3"; //Fix:Storekeeper:19.09
		break;


///////////////////////////////////////////////////////////////
///// SINK THE PIRATE CORVETTE
///////////////////////////////////////////////////////////////


		case "joseph_claude_le_mougne_english_war_ship":
			characters[GetCharacterIndex("joseph claude le moigne")].quest.english_war_ship = "1";

			SetCharacterRelation(GetCharacterIndex("Eng Captain Near FdF"),GetMainCharacterIndex(),RELATION_ENEMY);
			SetCharacterRelation(GetCharacterIndex("FalaiseDeFleur Commander"),GetCharacterIndex("Eng Captain Near FdF"),RELATION_ENEMY);
			
			Group_CreateGroup("Eng Captain Near FdF");
			Group_AddCharacter("Eng Captain Near FdF", "Eng Captain Near FdF");
			Group_SetGroupCommander("Eng Captain Near FdF", "Eng Captain Near FdF");
			Group_SetAddress("Eng Captain Near FdF", "FalaiseDeFleur", "Quest_Ships","Quest_Ship_12");
			Group_SetTaskAttack("Eng Captain Near FdF", PLAYER_GROUP);

			UpdateRelations();

			SetQuestHeader("Hire_by_france_for_defeat_england_corvette");
			AddQuestRecord("Hire_by_france_for_defeat_england_corvette", 1);
			pchar.quest.killing_pirate_near_fdf.win_condition.l1 = "NPC_death";
			pchar.quest.killing_pirate_near_fdf.win_condition.l1.character = "Eng Captain Near FdF";
			pchar.quest.killing_pirate_near_fdf.win_condition = "killing_pirate_near_fdf";
		break;

		case "killing_pirate_near_fdf":
			characters[getCharacterindex("Joseph Claude Le Moigne")].quest.english_war_ship = "2";
		break;


///////////////////////////////////////////////////////////////
// ESCORT VIGILA MENDES' SHIP + ZAID MURRO'S PROBLEM
///////////////////////////////////////////////////////////////


		case "Mendes_go_away_from_muelle_store":
			pchar.quest.death_of_vigila_mendes.win_condition.l1 = "NPC_death";
			pchar.quest.death_of_vigila_mendes.win_condition.l1.character = "Vigila Mendes";
			pchar.quest.death_of_vigila_mendes.win_condition = "death_of_vigila_mendes_complete";
			
			LAi_SetActorType(characterFromID("Vigila Mendes"));

			Lai_ActorGoToLocator(characterFromID("Vigila Mendes"), "reload", "locator2", "Mendes_go_away_from_muelle_store_complete", 2.0);
		break;

		case "Mendes_go_away_from_muelle_store_complete":
			SetCompanionIndex(pchar,-1, GetCharacterIndex("Vigila Mendes"));
			SetCharacterRemovable(characterFromID("Vigila Mendes"), false);
			//ChangeCharacterAddress(CharacterFromID("Zaid Murro"), "none", "none"); //NK disabled 1
			ChangeCharacterAddress(characterFromID("Vigila Mendes"), "Falaise_De_Fleur_Store", "goto5");
			LAi_ActorWaitDialog(characterFromID("Vigila Mendes"), pchar);
			AddCharacterGoods(CharacterFromID("Vigila Mendes"), GOOD_EBONY, 500);
		break;

		case "Mendes_go_away_from_falaise_de_fleur_store":
			Lai_ActorGoToLocator(characterFromID("Vigila Mendes"), "reload", "reload1", "Mendes_go_away_from_falaise_de_fleur_store_complete", 2.0);
		break;

		case "vigila_to_muelle_tavern":
			Lai_ActorWaitDialog(characterFromID("Vigila Mendes"), pchar);
		break;

		case "Mendes_go_away_from_falaise_de_fleur_store_complete":
			ChangeCharacterAddress(characterFromID("Vigila Mendes"), "Muelle_store", "locator5");
			LAi_ActorWaitDialog(characterFromID("Vigila Mendes"), pchar);
			AddCharacterGoods(characterFromID("Vigila Mendes"), GOOD_LINEN, 500);
		break;

		case "death_of_vigila_mendes_complete":
			//ChangeCharacterAddress(CharacterFromID("Zaid Murro"), "none", "none"); //NK disabled 2
			AddQuestRecord("mendes", 4);
			CloseQuestHeader("mendes");
			ChangeCharacterReputation(pchar, -2);
		break;
		
		case "mendes_away_forewer":
			LAi_SetActorType(characterFromID("Vigila Mendes"));
			LAi_ActorGoToLocation(characterFromID("Vigila Mendes"), "reload", "locator2", "none", "", "", "", 3.0);
			//ZAID MURRO -     
			//ChangeCharacterAddress(characterFromID("Zaid Murro"), "none", ""); //NK disable this (dunno why it's here but it breaks Zaid)
		break;

		case "zaid_to_muelle_town":
			LAi_ActorGoToLocator(characterFromID("Zaid Murro"),"reload", "reload2", "zaid_to_muelle_town_complete", 2.0);
		break;

		case "zaid_to_muelle_town_complete":
			ChangeCharacterAddress(CharacterFromID("Zaid Murro"), "Muelle_town_01", "goto4");
			LAi_SetStayType(CharacterFromID("Zaid Murro"));
		break;

		case "revenge_for_bandits":
			ChangeCharacterAddress(CharacterFromID("danielle_quests_corsair_1"), "Muelle_town_exit", "locator9");
			ChangeCharacterAddress(CharacterFromID("danielle_quests_corsair_2"), "Muelle_town_exit", "citizen01");
// NK -->
			Characters[GetCharacterIndex("danielle_quests_corsair_1")].greeting = "Gr_isla muelle soldier";
			Characters[GetCharacterIndex("danielle_quests_corsair_2")].greeting = "Gr_isla muelle soldier";
			Characters[GetCharacterIndex("danielle_quests_corsair_3")].greeting = "Gr_isla muelle soldier";
			Characters[GetCharacterIndex("danielle_quests_corsair_4")].greeting = "Gr_isla muelle soldier"; // Julian
			Characters[GetCharacterIndex("danielle_quests_corsair_5")].greeting = "Gr_isla muelle soldier"; // Julian
			LAi_SetActorType(CharacterFromID("danielle_quests_corsair_1"));
			Lai_ActorWaitDialog(characterFromID("danielle_quests_corsair_1"), pchar);
			LAi_SetActorType(CharacterFromID("danielle_quests_corsair_2")); // Julian
			Lai_ActorWaitDialog(characterFromID("danielle_quests_corsair_2"), pchar); // Julian
// NK <--
		break;

		case "fight_with_bandits_in_muelle_town_exit":
			AddQuestrecord("murro", 2);
			LAi_group_MoveCharacter(characterFromID("danielle_quests_corsair_1"), "BANDITS");
			LAi_group_MoveCharacter(characterFromID("danielle_quests_corsair_2"), "BANDITS");
			LAi_group_FightGroups("BANDITS", LAI_GROUP_PLAYER, true);
			LAi_group_SetCheck("BANDITS", "fight_with_other_bandits_in_muelle_town_exit"); //NK fix
		break;

		case "fight_with_other_bandits_in_muelle_town_exit":
			DisableFastTravel(true);
			DisableMenuLaunch(true);
			DoQuestCheckDelay("fight_with_other_bandits_in_muelle_town_exit_2", 3.0);
		break;

		case "fight_with_other_bandits_in_muelle_town_exit_2":
			DisableFastTravel(false);
			DisableMenuLaunch(false);
			AddQuestrecord("murro", 3);
			ReanimateCharacter("danielle_quests_corsair_1");
			ReanimateCharacter("danielle_quests_corsair_2");
			ReanimateCharacter("danielle_quests_corsair_3");
// Julian -->
			ChangeCharacterAddressGroup(CharacterFromID("danielle_quests_corsair_4"), "none", "reload", "reload1");
			ChangeCharacterAddressGroup(CharacterFromID("danielle_quests_corsair_5"), "none", "reload", "reload1");
			LAi_SetActorType(CharacterFromID("danielle_quests_corsair_4"));
			LAi_SetActorType(CharacterFromID("danielle_quests_corsair_5"));
			ChangeCharacterAddressGroup(CharacterFromID("danielle_quests_corsair_3"), "Muelle_town_exit", "reload", "reload1");
			ChangeCharacterAddressGroup(CharacterFromID("danielle_quests_corsair_4"), "Muelle_town_exit", "reload", "reload1");
			ChangeCharacterAddressGroup(CharacterFromID("danielle_quests_corsair_5"), "Muelle_town_exit", "reload", "reload1");
			LAi_ActorFollow(CharacterFromID("danielle_quests_corsair_4"), CharacterFromID("danielle_quests_corsair_3"), "", 20);
			LAi_ActorFollow(CharacterFromID("danielle_quests_corsair_5"), CharacterFromID("danielle_quests_corsair_3"), "", 30);
			characters[GetCharacterIndex("Zaid Murro")].quest.bandits = "2";
			LAi_SetActorType(CharacterFromID("danielle_quests_corsair_3"));
			LAi_ActorDialog(CharacterFromID("danielle_quests_corsair_3"), pchar, "", 4.0, 1.0);
// Julian <--
		break;

		case "fight_with_other_bandits_in_muelle_town_exit_3":
			LAi_group_MoveCharacter(characterFromID("danielle_quests_corsair_3"), "BANDITS"); // Julian
			LAi_group_MoveCharacter(characterFromID("danielle_quests_corsair_4"), "BANDITS"); // Julian
			LAi_group_MoveCharacter(characterFromID("danielle_quests_corsair_5"), "BANDITS"); // Julian
			LAi_group_FightGroups("BANDITS", LAI_GROUP_PLAYER, true);
			LAi_group_SetCheck("BANDITS", "fight_with_other_bandits_in_muelle_town_exit_4"); //NK fix
		break;

		case "fight_with_other_bandits_in_muelle_town_exit_4":
			AddQuestrecord("murro", 4);
			characters[GetCharacterIndex("Zaid Murro")].quest.bandits = "3";
		break;


///////////////////////////////////////////////////////////////
// HELP THE BOATSWAIN + HELP THE LADY (CatalinaThePirate FB Quest)
///////////////////////////////////////////////////////////////


		case "fred_bob_becomes_officer":
			SetOfficersIndex(Pchar, 2, GetCharacterIndex("Fred Bob"));
			pchar.quest.fred_bob = "0";
			CloseQuestHeader("fred_bob");
		break;
		
		case "story_fred_bob_fired":
			RemoveOfficersIndex(pchar, GetCharacterIndex("Fred Bob"));
			RemovePassenger(pchar, characterFromID("Fred Bob"));
			LAi_ActorGoToLocation(characterFromID("Fred Bob"), "Muelle_port", "goto", "goto9", "", "", "", 25.0);
			LAi_QuestDelay("story_fred_bob_fired2", 25.0);
		break;	

		case "story_fred_bob_fired2":
			ChangeCharacterAddress(characterFromID("Fred Bob"), "Muelle_port", "goto9");
			LAi_SetCitizenType(characterFromID("Fred Bob"));
			Characters[GetCharacterIndex("Fred Bob")].Dialog.CurrentNode = "come_back_fredbob";
		break;
		
		case "story_fred_bob_fired3":
			Characters[GetCharacterIndex("Fred Bob")].Dialog.CurrentNode = "come_back_fredbob2";
		break;
		
		case "Story_gotoQC":
			ChangeCharacterAddressGroup(characterFromID("Armand Delacroix"), "QC_tavern", "Sit", "Sit8");
			pchar.quest.estrella_qc = "here";
		break;

		case "Story_SitAndDrinkWithDelacroix":
			LAi_Fade("Story_SitAndDrinkWithDelacroix_2", "Story_DelacroixStartTalkingInTavern");
		break;
		
		case "Story_SitAndDrinkWithDelacroix_2":
			LAi_SetActorType(pchar);
			LAi_ActorSetSitMode(pchar);
			ChangeCharacterAddressGroup(pchar, "QC_tavern", "sit", "sit4");
		break
		
		case "Story_DelacroixStartTalkingInTavern":
			SetCurrentTime(23, 0);
			LAi_ActorDialogNow(Pchar, characterFromID("Armand Delacroix"), "", -1);
		break;
		
		case "Story_SitAndDrinkWithDelacroix3":
			LAi_Fade("Story_SitAndDrinkWithDelacroix_4", "Story_DelacroixGiddy");
		break;

		case "Story_SitAndDrinkWithDelacroix_4":
			LAi_SetActorType(characterFromID("Armand Delacroix"));
			ChangeCharacterAddress(characterFromID("Armand Delacroix"), "QC_port", "goto19");
			DoQuestReloadToLocation("QC_port", "goto", "goto18", "Story_DelacroixGiddy");
		break

		case "Story_DelacroixGiddy":
			SetCurrentTime(4, 0);
			LAi_ActorTurnToCharacter(characterFromID("Armand Delacroix"), PChar);
			LAi_ActorDialog(characterfromID("Armand Delacroix"), pchar, "", 1.0, 1.0);
			Characters[GetCharacterIndex("Armand Delacroix")].Dialog.CurrentNode = "giddy";	
		break;
		
		case "Story_Exit_StageLeft":
			DeleteQuestAttribute("estrella_qc");
			LAi_ActorRunToLocation(characterFromID("Armand Delacroix"), "reload", "reload3", "none", "", "", "", 45.0);
		break;

		case "Story_Estrella_Reload_to_IMGate":
			ChangeCharacterAddressGroup(characterFromID("Estrella De Alencar"), "none", "none", "none");	
			SetCurrentTime(1, 0);
			Locations[FindLocation("Muelle_town_03")].vcskip = true; // NK
			StoreOfficers(pchar.id); // KK
			DoQuestReloadToLocation("Muelle_town_01", "reload", "reload14", "Story_Estrella_Afraid");
		break;
		
		case "Story_Estrella_Afraid":
			LAi_SetActorType(characterFromID("Estrella Disguised"));
			LAi_ActorWaitDialog(Pchar, characterFromID("Estrella Disguised"));
			LAi_ActorDialog(characterFromID("Estrella Disguised"), Pchar, "", 7.0, 0);
		break;
		
		case "Story_EstrellaBecomesOfficer":
			SetOfficersIndex(Pchar, 3, GetCharacterIndex("Estrella Disguised"));	
			characters[GetCharacterIndex("Estrella Disguised")].dialog.currentnode = "reunited";
			Locations[FindLocation("Muelle_shore")].vcskip = true; 
// KK -->
			homelocation = Characters[GetCharacterIndex("spain_soldier_05")].location;
			homegroup = Characters[GetCharacterIndex("spain_soldier_05")].location.group;
			homelocator = Characters[GetCharacterIndex("spain_soldier_05")].location.locator;

			pchar.quest.Story_stop_estrella.win_condition.l1 = "locator";
			pchar.quest.Story_stop_estrella.win_condition.l1.location = homelocation;
			pchar.quest.Story_stop_estrella.win_condition.l1.locator_group = homegroup;
			pchar.quest.Story_stop_estrella.win_condition.l1.locator = homelocator;
			pchar.quest.Story_stop_estrella.win_condition = "Story_stop_estrella";

			Locations[FindLocation(homelocation)].locators_radius.(homegroup).(homelocator).old = Locations[FindLocation(homelocation)].locators_radius.(homegroup).(homelocator);
			Locations[FindLocation(homelocation)].locators_radius.(homegroup).(homelocator) = 5.0;
// <-- KK
		break;
		
		case "Story_stop_estrella":
			LAi_SetActorType(characterFromID("spain_soldier_05"));
			characters[GetCharacterIndex("spain_soldier_05")].dialog.currentnode = "stop_estrella";
			LAi_ActorWaitDialog(Pchar, characterFromID("spain_soldier_05"));
			LAi_ActorDialogNow(characterFromID("spain_soldier_05"), pchar, "Story_stop_estrella1", -1);
		break;

		case "Story_stop_estrella1":
// KK -->
			homelocation = Characters[GetCharacterIndex("spain_soldier_05")].location;
			homegroup = Characters[GetCharacterIndex("spain_soldier_05")].location.group;
			homelocator = Characters[GetCharacterIndex("spain_soldier_05")].location.locator;
			Locations[FindLocation(homelocation)].locators_radius.(homegroup).(homelocator) = Locations[FindLocation(homelocation)].locators_radius.(homegroup).(homelocator).old;
			DeleteAttribute(&Locations[FindLocation(homelocation)], "locators_radius." + homegroup + "." +homelocator + ".old");
// <-- KK
			LAi_SetGuardianType(characterFromID("spain_soldier_05"));
			LAi_group_MoveCharacter(characterFromID("spain_soldier_05"), "SPAIN_SOLDIERS");
			Pchar.quest.Story_EstrellaReunited.win_condition.l1 = "location";
			Pchar.quest.Story_EstrellaReunited.win_condition.l1.location = "Muelle_town_exit";
			Pchar.quest.Story_EstrellaReunited.win_condition = "estrella_disguised_exit_run";
		break;
			
		case "estrella_disguised_exit_run":		
			LAi_SetActorType(characterFromID("Estrella Disguised"));
			LAi_ActorWaitDialog(Pchar, characterFromID("Estrella Disguised"));
			characters[GetCharacterIndex("Estrella Disguised")].dialog.currentnode = "close_call";
			LAi_ActorDialog(characterFromID("Estrella Disguised"), Pchar, "", 1.0, 0);
			ChangeCharacterAddress(characterFromID("Armand Delacroix"), "Muelle_shore", "goto8");
		break;
		
		case "estrella_disguised_exit_run1":	
			LAi_SetOfficerType(characterFromID("Estrella Disguised"));
			Pchar.quest.Story_EstrellaReunited.win_condition.l1 = "location";
			Pchar.quest.Story_EstrellaReunited.win_condition.l1.location = "Muelle_shore";
			Pchar.quest.Story_EstrellaReunited.win_condition = "estrella_disguised_exit_run2";		
		break;
	
		case "estrella_disguised_exit_run2":
			LAi_SetActorType(characterFromID("Estrella Disguised"));
			LAi_ActorWaitDialog(Pchar, characterFromID("Estrella Disguised"));
			characters[GetCharacterIndex("Estrella Disguised")].dialog.currentnode = "reunited";
			LAi_ActorDialog(characterFromID("Estrella Disguised"), Pchar, "", 4.0, 0);
		break;

		case "estrella_disguised_attack1":
			LAi_group_FightGroups("SPAIN_SOLDIERS", LAI_GROUP_PLAYER, true);
			DeleteAttribute(&Locations[FindLocation("Muelle_town_03")],"vcskip");
			LAi_group_Register("FBQ_SPAIN_SOLDIERS");
			LAi_group_Register("FBQ_Armand");
			LAi_group_MoveCharacter(characterFromID("Armand Delacroix"), "FBQ_Armand");
			LAi_group_SetRelation("FBQ_SPAIN_SOLDIERS", "FBQ_Armand", LAI_GROUP_NEITRAL);
			LAi_QuestDelay("estrella_disguised_attack2", 1.0);
		break;	
			
		case "estrella_disguised_attack2":
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[SPAIN].fantomModel.m1, "goto", "goto7"); // PB
			LAi_group_MoveCharacter(sld, "FBQ_SPAIN_SOLDIERS");
			
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[SPAIN].fantomModel.m2, "goto", "goto7"); // PB
			LAi_group_MoveCharacter(sld, "FBQ_SPAIN_SOLDIERS");
			
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[SPAIN].fantomModel.m3, "goto", "goto7"); // PB
			LAi_group_MoveCharacter(sld, "FBQ_SPAIN_SOLDIERS");
			
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[SPAIN].fantomModel.m4, "goto", "goto7"); // PB
			LAi_group_MoveCharacter(sld, "FBQ_SPAIN_SOLDIERS");
			
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[SPAIN].fantomModel.m5, "goto", "goto7"); // PB
			LAi_group_MoveCharacter(sld, "FBQ_SPAIN_SOLDIERS");
			
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[SPAIN].fantomModel.m6, "goto", "goto7"); // PB
			LAi_group_MoveCharacter(sld, "FBQ_SPAIN_SOLDIERS");
			
			LAi_group_FightGroups("FBQ_SPAIN_SOLDIERS", LAI_GROUP_PLAYER, true);

			LAi_QuestDelay("estrella_disguised_attack3", 1.0);
		break;

		case "estrella_disguised_attack3":	
			characters[GetCharacterIndex("Estrella Disguised")].dialog.currentnode = "reunited2";
			LAi_SetActorType(characterFromID("Estrella Disguised"));
			LAi_ActorWaitDialog(Pchar, characterFromID("Estrella Disguised"));
			LAi_ActorDialog(characterFromID("Estrella Disguised"), Pchar, "", 4.0, 0);
			DeleteAttribute(&Locations[FindLocation("Muelle_shore")],"vcskip");
		break;

		case "estrella_disguised_attack4":
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[SPAIN].fantomModel.m1, "goto", "goto7"); // PB
			LAi_group_MoveCharacter(sld, "FBQ_SPAIN_SOLDIERS");
			
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[SPAIN].fantomModel.m2, "goto", "goto7"); // PB
			LAi_group_MoveCharacter(sld, "FBQ_SPAIN_SOLDIERS");
			
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[SPAIN].fantomModel.m3, "goto", "goto7"); // PB
			LAi_group_MoveCharacter(sld, "FBQ_SPAIN_SOLDIERS");
			
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[SPAIN].fantomModel.m4, "goto", "goto7"); // PB
			LAi_group_MoveCharacter(sld, "FBQ_SPAIN_SOLDIERS");
			
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[SPAIN].fantomModel.m5, "goto", "goto7"); // PB
			LAi_group_MoveCharacter(sld, "FBQ_SPAIN_SOLDIERS");
			
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[SPAIN].fantomModel.m6, "goto", "goto7"); // PB
			LAi_group_MoveCharacter(sld, "FBQ_SPAIN_SOLDIERS");
			
			LAi_group_FightGroups("FBQ_SPAIN_SOLDIERS", LAI_GROUP_PLAYER, true);
			LAi_SetOfficerType(characterFromID("Estrella Disguised"));

			LAi_QuestDelay("estrella_disguised_attack5", 6.0);
		break;
		
		case "estrella_disguised_attack5":
			LAi_group_SetRelation("FBQ_SPAIN_SOLDIERS", "FBQ_Armand", LAI_GROUP_ENEMY);
			LAi_group_FightGroups("FBQ_SPAIN_SOLDIERS", "FBQ_Armand", true);
			LAi_QuestDelay("Story_Reunited2", 3.0);
		break;	
		
		case "Story_Reunited2":
			LAi_group_SetCheck("FBQ_SPAIN_SOLDIERS", "Story_Reunited3");
		break;		
		
		case "Story_Reunited3":
			characters[GetCharacterIndex("Armand Delacroix")].dialog.currentnode = "reunited_flight";
			LAi_SetActorType(characterFromID("Armand Delacroix"));
			LAi_ActorWaitDialog(Pchar, characterFromID("Armand Delacroix"));
			LAi_ActorDialog(characterFromID("Armand Delacroix"), Pchar, "", 20.0, 0);
		break;		

		case "Story_estrella_farewell":	
			characters[GetCharacterIndex("Estrella Disguised")].dialog.currentnode = "estrella_farewell";
			LAi_SetActorType(characterFromID("Estrella Disguised"));
			LAi_ActorWaitDialog(Pchar, characterFromID("Estrella Disguised"));
			LAi_ActorDialog(characterFromID("Estrella Disguised"), Pchar, "", 4.0, 0);
		break;	
		
		case "Story_Exit_StageRight":
			RemoveOfficersIndex(pchar, GetCharacterIndex("Estrella Disguised"));
			RemovePassenger(pchar, characterFromID("Estrella Disguised"));
			RestoreOfficers(pchar.id); // KK
			LAi_SetActorType(characterFromID("Armand Delacroix"));
			LAi_SetActorType(characterFromID("Estrella Disguised"));
			LAi_ActorRunToLocation(characterFromID("Armand Delacroix"), "goto", "goto11", "none", "", "", "", 20.0);
			LAi_ActorRunToLocation(characterFromID("Estrella Disguised"), "goto", "goto11", "none", "", "", "", 20.0);
			LAi_QuestDelay("Story_Armand_and_Estrella_Escape", 20.0);
		break;	
		
		case "Story_Armand_and_Estrella_Escape":
			ChangeCharacterAddress(characterFromID("Armand Delacroix"), "", "");
			ChangeCharacterAddress(characterFromID("Estrella Disguised"), "", "");
			LAi_group_SetRelation("SPAIN_SOLDIERS", LAI_GROUP_PLAYER, LAI_GROUP_NEITRAL);
			LAi_group_SetRelation("FBQ_SPAIN_SOLDIERS", LAI_GROUP_PLAYER, LAI_GROUP_NEITRAL);
			LAi_group_FightGroups("FBQ_SPAIN_SOLDIERS", LAI_GROUP_PLAYER, false);
		break;	
		
		case "Story_Armand_refused":
			LAi_SetPlayerType(Pchar);
			ChangeCharacterAddress(pchar, "qc_tavern", "goto5");
		break;	
		

///////////////////////////////////////////////////////////////
// FIND ANQELIQUE MOULIN'S FATHER (Missing Man quest)
///////////////////////////////////////////////////////////////


		case "Missing_start":
			SetEnterLocationQuest("PoPrince_town", "Missing_start_check", 0);
		break;

		case "Missing_start_check":
			if(makeint(PChar.rank) >= 15)
			{
				ChangeCharacterAddressGroup(CharacterFromID("Angelique Moulin"), "PoPrince_town", "goto", "goto17");
			}
		break;

		case "Missing_search_refused":
			PChar.quest.Missingman = "refused";
			DeleteEnterLocationQuest("PoPrince_town", "Missing_start_check");
			LAi_SetActorType(characterFromID("Angelique Moulin"));
			LAi_ActorGoToLocation(characterFromID("Angelique Moulin"), "reload", "reload19", "none", "", "", "", 0.0);
			SetQuestHeader("Moulin");
			AddQuestRecord("Moulin", 9);
			CloseQuestHeader("Moulin");
		break;

		case "Missing_start_search":
			LAi_SetCitizenType(CharacterFromID("Angelique Moulin"));
			PChar.quest.Missingman = "search";
			DeleteEnterLocationQuest("PoPrince_town", "Missing_start_check");
			bSuppressResurrection = true;
			SetQuestHeader("Moulin");
			AddQuestRecord("Moulin", 1);
			ChangeCharacterAddressGroup(CharacterFromID("Robert Durand"), "Buccaneers_Camp", "goto", "goto16");
			ChangeCharacterAddressGroup(CharacterFromID("Buccaneer_01"), "Buccaneers_Camp", "goto", "goto42");
			ChangeCharacterAddressGroup(CharacterFromID("Buccaneer_02"), "Buccaneers_Camp", "goto", "goto12");
			ChangeCharacterAddressGroup(CharacterFromID("Buccaneer_03"), "Buccaneers_Camp", "goto", "goto15");
			Characters[GetCharacterIndex("Robert Durand")].dialog.currentnode = "First time";
		break;

		case "moulinplage":
			PChar.quest.Missingman = "voirmoulin";
			AddQuestRecord("Moulin", 2);
			LAi_SetPlayerType (Pchar);
			LAi_SetActorType(characterFromID("Robert Durand"));
			LAi_ActorGoToLocation(characterFromID("Robert Durand"), "reload", "reload6", "none", "", "", "", 0.0);
			setCharacterShipLocation(characterFromID("Pieter Boelen"), "Hispaniola_shore_02");
			ChangeCharacterAddressGroup(CharacterFromID("Francois Moulin"), "Hispaniola_shore_02", "goto", "locator12");
		break;

		case "directionlefort":
			PChar.quest.Missingman = "voirchamfort";
			AddQuestRecord("Moulin", 3);
			LAi_SetOfficerType(characterFromID("Robert Durand"));
			ChangeCharacterAddress(characterFromID("Robert Durand"), "none", "");
			ChangeCharacterAddressGroup(CharacterFromID("Antoine Chamfort"), "PoPrince_fakefort3", "reload", "reloadc4");
		break;

		case "antoinefort":
			locations[FindLocation("PoPrince_fakefort3")].reload.l1.disable = 1;
			locations[FindLocation("PoPrince_fakefort3")].reload.l2.disable = 1;
			locations[FindLocation("PoPrince_fakefort3")].reload.l3.disable = 1;
			LAi_SetActorType(pchar);
			LAi_ActorGoToLocation(PChar, "reload", "reload2", "none", "", "", "", 50);
			LAi_QuestDelay("coupbas", 1.0);
		break;

		case "coupbas":
			LAi_SetPlayerType (Pchar);
			LAi_SetActorType(characterFromID("Antoine Chamfort"));
			LAi_ActorAttack(CharacterFromID("Antoine Chamfort"), PChar, "");
			pchar.quest.killing_chamfort.win_condition.l1 = "NPC_Death";
			pchar.quest.killing_chamfort.win_condition.l1.character = "Antoine Chamfort";
			pchar.quest.killing_chamfort.win_condition = "killing_chamfort";
		break;

		case "killing_chamfort":
			if(AUTO_SKILL_SYSTEM)
			{
				AddPartyExpChar(pchar, "Leadership", 2500);
				AddPartyExpChar(pchar, "Sneak", 200);
			}
			else { AddPartyExp(pchar, 2500); }
			locations[FindLocation("PoPrince_fakefort3")].reload.l1.disable = 0;
			locations[FindLocation("PoPrince_fakefort3")].reload.l2.disable = 0;
			locations[FindLocation("PoPrince_fakefort3")].reload.l3.disable = 0;
			LAi_group_SetRelation("FRANCE_SOLDIERS", LAI_GROUP_PLAYER, LAI_GROUP_ENEMY);
			LAi_group_SetAlarm("FRANCE_SOLDIERS", LAI_GROUP_PLAYER, 0.0);
			AddQuestRecord("Moulin", 4);
			setCharacterShipLocation(characterFromID("Pieter Boelen"), "none"); 
			Characters[GetCharacterIndex("Francois Moulin")].dialog.currentnode = "begin_9";
			ChangeCharacterAddressGroup(CharacterFromID("Francois Moulin"), "Buccaneers_Camp", "goto", "goto37");
			ChangeCharacterAddress(characterFromID("Antoine Chamfort"), "none", "");

		break;

		case "retourprince":
			AddQuestRecord("Moulin", 5);
			LAi_SetActorType(characterFromID("Francois Moulin"));
			LAi_ActorFollowEverywhere(characterFromID("Francois Moulin"), "", 60.0);
			Characters[GetCharacterIndex("Angelique Moulin")].dialog.currentnode = "begin_6";
		break;

		case "recompense":
			Characters[GetCharacterIndex("Francois Moulin")].dialog.currentnode = "begin_12";
			LAi_SetActorType(characterFromID("Francois Moulin"));
			LAi_ActorDialog(characterFromID("Francois Moulin"), pchar, "", 1.0, 1.0);
		break;

		case "justebijou":
			LAi_SetOfficerType(characterFromID("Buccaneer_01"));
			ChangeCharacterAddress(characterFromID("Buccaneer_01"), "none", "");
			LAi_SetOfficerType(characterFromID("Buccaneer_02"));
			ChangeCharacterAddress(characterFromID("Buccaneer_02"), "none", "");
			LAi_SetOfficerType(characterFromID("Buccaneer_03"));
			ChangeCharacterAddress(characterFromID("Buccaneer_03"), "none", "");
			if(AUTO_SKILL_SYSTEM)
			{
				AddPartyExpChar(pchar, "Leadership", 12500);
				AddPartyExpChar(pchar, "Sneak", 200);
			}
			else { AddPartyExp(pchar, 12500); }
			bSuppressResurrection = false;
			AddQuestRecord("Moulin", 6);
			CloseQuestHeader("Moulin");
			GiveItem2Character(pchar, "jewelry2");
			LAi_SetActorType(characterFromID("Francois Moulin"));
			LAi_ActorGoToLocation(characterFromID("Francois Moulin"), "reload", "reload19", "none", "", "", "", 0.0);
			LAi_SetActorType(characterFromID("Angelique Moulin"));
			LAi_ActorGoToLocation(characterFromID("Angelique Moulin"), "reload", "reload19", "none", "", "", "", 0.0);
		break;

		case "lesdeuxchoses":
			LAi_SetOfficerType(characterFromID("Buccaneer_01"));
			ChangeCharacterAddress(characterFromID("Buccaneer_01"), "none", "");
			LAi_SetOfficerType(characterFromID("Buccaneer_02"));
			ChangeCharacterAddress(characterFromID("Buccaneer_02"), "none", "");
			LAi_SetOfficerType(characterFromID("Buccaneer_03"));
			ChangeCharacterAddress(characterFromID("Buccaneer_03"), "none", "");
			if(AUTO_SKILL_SYSTEM)
			{
				AddPartyExpChar(pchar, "Leadership", 12500);
				AddPartyExpChar(pchar, "Sneak", 200);
			}
			else { AddPartyExp(pchar, 12500); }
   			bSuppressResurrection = false;
			AddQuestRecord("Moulin", 7);
			GiveItem2Character(pchar, "jewelry2");
			GiveItem2Character(pchar, OLD_JOURNAL);
			LAi_SetActorType(characterFromID("Francois Moulin"));
			LAi_ActorGoToLocation(characterFromID("Francois Moulin"), "reload", "reload19", "none", "", "", "", 0.0);
			LAi_SetActorType(characterFromID("Angelique Moulin"));
			LAi_ActorGoToLocation(characterFromID("Angelique Moulin"), "reload", "reload19", "none", "", "", "", 0.0);

			pchar.quest.epeeperdue.win_condition.l1 = "locator";
			pchar.quest.epeeperdue.win_condition.l1.location = "Antigua_Jungle_01";
			pchar.quest.epeeperdue.win_condition.l1.locator_group = "goto";
			pchar.quest.epeeperdue.win_condition.l1.locator = "citizen010";
			pchar.quest.epeeperdue.win_condition = "cachette";
		break;

		case "cachette":
			LAi_SetActorType(Pchar);
			Pchar.Temp.self.dialog = Pchar.dialog.currentnode;
			Pchar.dialog.currentnode = "Francis_sword";
			LAi_ActorSelfDialog(Pchar, "player_back");
		break;

		case "jelaifini":
			if(AUTO_SKILL_SYSTEM)
			{
				AddPartyExpChar(pchar, "Leadership", 15000);
				AddPartyExpChar(pchar, "Sneak", 200);
			}
			else { AddPartyExp(pchar, 15000); }
			AddQuestRecord("Moulin", 8);
			CloseQuestHeader("Moulin");
			GiveItem2Character(pchar, "bladeFD");	// KevAtl update for new SLiB blades 09-07-2007
		break;


///////////////////////////////////////////////////////////////
// ELIZABETH SHAW'S DISAPPEARENCE (Davy Jones First Contact quest)
///////////////////////////////////////////////////////////////


		case "Contact_start":
			SetEnterLocationQuest("Grand_Cayman_townhall", "Contact_start_check", 0);
		break;

		case "Contact_start_check":
			if(makeint(PChar.rank) >= 6)
			{
				PChar.quest.Firstcontact = "debut";
			}
		break;

		case "Contact_start_search":
			PChar.quest.Firstcontact = "search";
			DeleteEnterLocationQuest("Grand_Cayman_townhall", "Contact_start_check");
			bSuppressResurrection = true;
			SetQuestHeader("Contact");
			AddQuestRecord("Contact", 1);
		break;

		case "Contact_arendt":
			PChar.quest.Firstcontact = "search2";
			AddQuestRecord("Contact", 9);
		break;

		case "searchdebris":
			PChar.quest.Firstcontact = "chest";
			AddQuestRecord("Contact", 5);

			Pchar.quest.find_dead.win_condition.l1 = "location";
			Pchar.quest.find_dead.win_condition.l1.location = "SaintMartin_shore_02";
			PChar.quest.find_dead.win_condition = "crewmemberdead";
		break;

		case "crewmemberdead":
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[ENGLAND].fantomModel.m2, "goto", "citizen07"); // PB
			LAi_SetActorType(sld);
			LAi_ActorSetLayMode(sld);
			LAi_SetImmortal(sld,true);
			sld.dialog.filename = "Octave Fabre_dialog.c";
			sld.dialog.currentnode = "Smallchest";
			LAi_ActorWaitDialog(sld, pchar);			//CTM
			LAi_ActorDialog(pchar, sld, "", 4.0, 1.0);	//CTM
		break;

		case "jela":
			if(AUTO_SKILL_SYSTEM)
			{
				AddPartyExpChar(pchar, "Leadership", 1500);
				AddPartyExpChar(pchar, "Sneak", 200);
			}
			else { AddPartyExp(pchar, 1500); }
			PChar.quest.Firstcontact = "oldadmiral";
			GiveItem2Character(pchar, SMALL_CHEST);
			ChangeCharacterAddressGroup(CharacterFromID("Octave Fabre"), "PaP_Academy", "sit", "sit1");
			ChangeCharacterAddress(characterFromID("Reynoud Verheugen"), "none", "");
			AddQuestRecord("Contact", 6);
		break;

		case "pap_storm":
			PChar.quest.Firstcontact = "warning";
			Pchar.quest.davycrew.win_condition.l1 = "location";
			Pchar.quest.davycrew.win_condition.l1.location = "Guadeloupe_Port";
			PChar.quest.davycrew.win_condition = "pap_storm1";
			DisableFastTravel(true);
			DisableMenuLaunch(true);
		break;

		case "pap_storm1":
			LAi_SetActorType(Pchar);
			Pchar.Temp.self.dialog = Pchar.dialog.currentnode;
			Pchar.dialog.currentnode = "pap_storm";
			LAi_ActorSelfDialog(Pchar, "player_back");
		break;

		case "davywarning":
			ChangeCharacterAddressGroup(CharacterFromID("Davycrew_01"), "Guadeloupe_Port", "goto", "goto24");
			ChangeCharacterAddressGroup(CharacterFromID("Davycrew_02"), "Guadeloupe_Port", "goto", "goto3");
			LAi_SetActorType(CharacterFromID("Davycrew_02"));
			LAi_ActorFollow(CharacterFromID("Davycrew_02"), pchar, "", 10);
			LAi_SetActorType(characterfromID("davycrew_01"));
			LAi_ActorDialog(characterfromID("davycrew_01"), PChar, "", 0.5, 10);
		break;

		case "Contact_antigua":
			DisableFastTravel(false);
			DisableMenuLaunch(false);
			ChangeCharacterAddressGroup(CharacterFromID("Davycrew_01"), "", "", "");
			ChangeCharacterAddressGroup(CharacterFromID("Davycrew_02"), "", "", "");
			Characters[GetCharacterIndex("antigua_portadmiral")].dialog.CurrentNode = "contact_return1";
			AddQuestRecord("Contact", 10);
		break;

		case "Contact_NoLuck":
			Characters[GetCharacterIndex("antigua_portadmiral")].dialog.CurrentNode = "First time";
			PChar.quest.Firstcontact = "prepare_davyencounter";
			AddQuestRecord("Contact", 11);
			Group_CreateGroup("FlyingDutchman");
			Group_AddCharacter("FlyingDutchman", "Davy Jones");
			Group_SetGroupCommander("FlyingDutchman", "Davy Jones");
			Group_SetPursuitGroup("FlyingDutchman", PLAYER_GROUP);
			Group_SetTaskAttack("FlyingDutchman", PLAYER_GROUP);
			Group_SetAddress("FlyingDutchman", "Cayman", "Quest_ships", "Quest_ship_12");
			Group_LockTask("FlyingDutchman");
			UpdateRelations();
			characters[GetCharacterIndex("Davy Jones")].nosurrender = 2;
			Character_SetAbordageEnable(characterFromID("Davy Jones"), false);
// KK -->
			PChar.quest.PrepareDavyEncounter.win_condition.l1 = "MapEnter";
			PChar.quest.PrepareDavyEncounter.win_condition = "PrepareDavyEncounter";
// <-- KK
		break;

// KK -->
		case "PrepareDavyEncounter":
			SetNextWeather("Day Storm");
			PChar.quest.StartDavyEncounter.win_condition.l1 = "SeaEnter";
			PChar.quest.StartDavyEncounter.win_condition = "StartDavyEncounter";
		break;

		case "StartDavyEncounter":
			PChar.quest.voirdavy.win_condition.l1 = "location";
			PChar.quest.voirdavy.win_condition.l1.location = GetCharacterShipQDeck(PChar);
			PChar.quest.voirdavy.win_condition = "voirdavy";

			bQuestDisableAllCommands = true;
			Sea_DeckStartNow(PChar, GetCharacterShipQDeck(PChar));
		break;
// <-- KK

		case "voirdavy":
			//ChangeCharacterAddressGroup(CharacterFromID("Davycrew_01"), PChar.location, "rld", "loc0");
			SetCharacterToNearLocatorFromMe("Davy Jones", 3);
			//SetCharacterToNearLocatorFromMe("Davycrew_01", 10);

			LAi_type_actor_Reset(characterFromID("Davycrew_02"));
			//ChangeCharacterAddressGroup(CharacterFromID("Davy Jones"), PChar.location, "rld", "loc2");
			LAi_SetActorType(pchar);
			LAi_SetActorType(characterFromID("Davy Jones"));
			LAi_ActorWaitDialog(CharacterFromID("Davy Jones"), Pchar);
			LAi_ActorDialog(pchar, characterFromID("Davy Jones"), "", 10.0, 1.0);
		break;

		case "davy_leave":
			ChangeCharacterAddressGroup(CharacterFromID("Davycrew_01"), "", "", "");
			ChangeCharacterAddressGroup(CharacterFromID("Davy Jones"), "", "", "");
			LAi_QuestDelay("meetdaughter", 1.0);
		break;

		case "meetdaughter":
			PChar.quest.Firstcontact = "daughter";
			ChangeCharacterAddress(characterFromID("Octave Fabre"), "none", "");
			SetCharacterToNearLocatorFromMe("Elizabeth Shaw", 3);
			LAi_SetActorType(pchar); 
			LAi_SetActorType(characterFromID("Elizabeth Shaw"));
			LAi_ActorWaitDialog(CharacterFromID("Elizabeth Shaw"), Pchar); 
			LAi_ActorDialog(pchar, characterFromID("Elizabeth Shaw"), "", 10.0, 1.0);
		break;

		case "sailtocayman":
			bQuestDisableAllCommands = false; // PB
			PChar.quest.Firstcontact = "gotocayman";
			AddQuestRecord("Contact", 7);
			ChangeCharacterAddressGroup(CharacterFromID("Edmund Christobel Shaw"), "Grand_Cayman_townhall", "goto", "goto6");
			LAi_SetCivilianGuardianType(characterFromID("Edmund Christobel Shaw"));

			Characters[GetCharacterIndex("Edmund Christobel Shaw")].dialog.CurrentNode = "gov_6";

			LAi_SetPlayerType(pchar);
			LAi_SetActorType(characterFromID("Elizabeth Shaw"));
			LAi_ActorFollowEverywhere(characterFromID("Elizabeth Shaw"), "", 60.0);
			SetCharacterRelationBoth(GetCharacterIndex("Davy Jones"),GetMainCharacterIndex(),RELATION_ENEMY);
			SetCharacterRelationBoth(GetCharacterIndex("Grand Cayman Commander"),GetCharacterIndex("Davy Jones"),RELATION_FRIEND);
			SetCharacterRelationBoth(GetCharacterIndex("Grand Cayman Commander"),GetMainCharacterIndex(),RELATION_FRIEND);
		break;

		case "goportcayman":
			LAi_SetPlayerType(pchar);
			LAi_type_actor_Reset(characterFromID("Elizabeth Shaw"));

			DisableFastTravel(true);
			DisableMenuLaunch(true);
			Pchar.quest.find_davy.win_condition.l1 = "locator";
			Pchar.quest.find_davy.win_condition.l1.location = "Grand_Cayman_townhall";
			pchar.quest.find_davy.win_condition.l1.locator_group = "reload";
			pchar.quest.find_davy.win_condition.l1.locator = "reload1";
			PChar.quest.find_davy.win_condition = "gotoseedavy";
		break;

		case "gotoseedavy":
			SetNextWeather("Black Pearl Fight");
			DoQuestReloadToLocation("Quest_Grand_Cayman_town", "reload", "reload15", "_");
			locations[FindLocation("Quest_Grand_Cayman_town")].reload.l1.disable = 1;
		break;

		case "davy_townfight1":
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[ENGLAND].fantomModel.m6, "goto", "goto28"); // PB
			LAi_SetActorType(sld);
			LAi_ActorSetLayMode(sld);
			LAi_SetImmortal(sld,true);

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[ENGLAND].fantomModel.m3, "goto", "goto29"); // PB
			LAi_SetActorType(sld);
			LAi_ActorSetLayMode(sld);
			LAi_SetImmortal(sld,true);

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[ENGLAND].fantomModel.m3, "goto", "goto14"); // PB
			LAi_SetActorType(sld);
			LAi_ActorSetLayMode(sld);
			LAi_SetImmortal(sld,true);

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[ENGLAND].fantomModel.m3, "goto", "goto1"); // PB
			LAi_SetActorType(sld);
			LAi_ActorSetLayMode(sld);
			LAi_SetImmortal(sld,true);

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[ENGLAND].fantomModel.m3, "goto", "goto2"); // PB
			LAi_SetActorType(sld);
			LAi_ActorSetLayMode(sld);
			LAi_SetImmortal(sld,true);

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[ENGLAND].fantomModel.m3, "officers", "reload13_3"); // PB
			LAi_SetActorType(sld);
			LAi_ActorSetLayMode(sld);
			LAi_SetImmortal(sld,true);

			// -------------------

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy1", "goto", "goto1");
			sld.name = "Angler";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy2", "goto", "goto3");
			sld.name = "Ogilvey";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");
 
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy3", "goto", "goto4");
			sld.name = "Maccus";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy4", "goto", "goto5");
			sld.name = "Clanker";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy5", "goto", "goto6");
			sld.name = "Hadras";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy1", "goto", "goto7");
			sld.name = "Urchin";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy2", "goto", "goto8");
			sld.name = "Wheelback";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy3", "goto", "goto9");
			sld.name = "Wyvern";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy4", "goto", "goto10");
			sld.name = "Quittance";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy5", "goto", "goto30");
			sld.name = "Penrod";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");

			LAi_group_FightGroups("DAVY_CREW", LAI_GROUP_PLAYER, true);

			LAi_group_SetCheck("DAVY_CREW", "davy_townfight2");
		break;

		case "davy_townfight2":
			//ChangeCharacterAddressGroup(characterFromID("Davy Jones"), "Quest_Cayman_Port", "officers", "sea_3");
			ChangeCharacterAddressGroup(characterFromID("Davy Jones"), "Quest_Cayman_Port", "goto", "goto8");
			LAi_SetCivilianGuardianType(characterFromID("Davy Jones"));
			ChangeCharacterAddressGroup(CharacterFromID("Davycrew_01"), "Quest_Cayman_Port", "goto", "soldier_01");
			ChangeCharacterAddressGroup(CharacterFromID("Davycrew_02"), "Quest_Cayman_Port", "goto", "goto3");
			Characters[GetCharacterIndex("Davy Jones")].dialog.CurrentNode = "begin_14";

			locations[FindLocation("Quest_Grand_Cayman_town")].reload.l1.disable = 0;
			setCharacterShipLocation(characterFromID("Davy Jones"), "Quest_Cayman_Port");
			Pchar.quest.davymeet.win_condition.l1 = "location";
			Pchar.quest.davymeet.win_condition.l1.location = "Quest_Cayman_Port";
			PChar.quest.davymeet.win_condition = "davyonshore";

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy1", "reload", "reload9");
			sld.name = "Angler";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy2", "officers", "reload9_1");
			sld.name = "Ogilvey";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");
 
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy3", "officers", "reload9_2");
			sld.name = "Maccus";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy4", "officers", "reload9_3");
			sld.name = "Clanker";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy5", "goto", "goto1");
			sld.name = "Hadras";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy1", "goto", "goto2");
			sld.name = "Urchin";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy2", "goto", "goto3");
			sld.name = "Wheelback";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy3", "reload", "reload8");
			sld.name = "Wyvern";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy4", "officers", "reload8_1");
			sld.name = "Quittance";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "davy5", "officers", "reload8_2");
			sld.name = "Penrod";
			sld.lastname = "";
			LAi_SetHP(sld, 80.0, 80.0);
			LAi_group_MoveCharacter(sld, "DAVY_CREW");

			LAi_group_FightGroups("DAVY_CREW", LAI_GROUP_PLAYER, true);
		break;

		case "davyonshore":
			PChar.quest.Firstcontact = "davytalks";
			Characters[GetCharacterIndex("Davycrew_01")].dialog.CurrentNode = "begin_5";
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "pirat3", "goto", "locator28");
			LAi_SetHP(sld, 80.0, 80.0);
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[ENGLAND].fantomModel.m6, "goto", "goto1"); // PB
			LAi_SetActorType(sld);
			LAi_ActorSetLayMode(sld);
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, Nations[ENGLAND].fantomModel.m3, "officers", "sea_1"); // PB
			LAi_SetActorType(sld);
			LAi_ActorSetLayMode(sld);
			LAi_SetActorType(characterfromID("davycrew_01"));
			LAi_ActorDialog(characterfromID("davycrew_01"), PChar, "", 0.5, 10);
		break;

		case "davyonshore2":
			LAi_SetActorType(pchar);
			LAi_ActorGoToLocator(PChar, "goto", "goto5", "davyonshore3", 10.0);
		break;

		case "davyonshore3":
			LAi_SetActorType(pchar);
			LAi_SetActorType(characterFromID("Davy Jones"));
			LAi_ActorWaitDialog(CharacterFromID("Davy Jones"), Pchar);
			LAi_ActorDialog(pchar, characterFromID("Davy Jones"), "", 10.0, 1.0);
		break;

		case "pushdavy":
			LAi_SetActorType(pchar);
			LAi_SetActorType(characterFromID("Davy Jones"));
			LAi_ActorAnimation(pchar, "attack_2", "davywater", 0.0);
			PlaySound("OBJECTS\duel\punch1.wav");
		break;

		case "davywater":
			//ChangeCharacterAddressGroup(characterFromID("Davy Jones"), "Quest_Cayman_Port", "reload", "sea");
			ChangeCharacterAddressGroup(characterFromID("Davy Jones"), "Quest_Cayman_Port", "goto", "goto7");
			LAi_SetActorType(characterFromID("Davy Jones"));
			LAi_ActorAnimation(characterFromID("Davy Jones"), "Ground_StandUp", "davyinwater", 3.0);
		break;

		case "davyinwater":
			LAi_SetActorType(pchar);
			LAi_SetActorType(characterFromID("Davy Jones"));
			Characters[GetCharacterIndex("Davy Jones")].dialog.currentnode = "begin_16";
			LAi_ActorWaitDialog(CharacterFromID("Davy Jones"), Pchar);
			LAi_ActorDialog(PChar, characterFromID("Davy Jones"), "", 0.0, 1.0);
		break;

		case "davyshootsme":
			LAi_SetPlayerType(pchar);
			LAi_SetActorType(characterFromID("Davy Jones"));
			LAi_ActorAttack(characterFromID("Davy Jones"), pchar, "");
			LAi_QuestDelay("davyhurtme", 2.7);
		break;

		case "davyhurtme":
			bSuppressResurrection = true;
			LAi_SetStayType(CharacterFromID("Davy Jones"));
			Lai_KillCharacter(pchar);
			LAi_QuestDelay("preroomcayman", 3.0);
			LAi_QuestDelay("goroomcayman", 6.0);
		break;

		case "preroomcayman":
			ChangeCharacterAddress(characterFromID("Davy Jones"), "none", "");
		break;

		case "goroomcayman":
			DoQuestReloadToLocation("Grand_Cayman_Tavern_upstairs", "goto", "goto4", "_");
			locations[FindLocation("Grand_Cayman_Tavern_upstairs")].reload.l1.disable = 1;
			LAi_SetPlayerType(pchar);
			LAi_SetHP(pchar, LAi_GetCharacterHP(pchar), LAi_GetCharacterHP(pchar));
			ChangeCharacterAddressGroup(CharacterFromID("Elizabeth Shaw"), "Grand_Cayman_Tavern_upstairs", "goto", "goto7");
			Characters[GetCharacterIndex("Elizabeth Shaw")].dialog.CurrentNode = "begin_4";
			LAi_SetActorType(characterfromID("Elizabeth Shaw"));
			LAi_ActorDialog(characterfromID("Elizabeth Shaw"), PChar, "", 0.5, 10);
			bSuppressResurrection = false;
		break;

		case "goresidencecayman":
			DisableFastTravel(false);
			DisableMenuLaunch(false);
			SetNextWeather("Blue Sky");
			locations[FindLocation("Grand_Cayman_Tavern_upstairs")].reload.l1.disable = 0;
			LAi_SetActorType(characterFromID("Elizabeth Shaw"));
			LAi_ActorGoToLocation(characterFromID("Elizabeth Shaw"), "reload", "reload1", "none", "", "", "", 0.0);
			Characters[GetCharacterIndex("Edmund Christobel Shaw")].dialog.CurrentNode = "gov_8";
			ChangeCharacterAddressGroup(CharacterFromID("Edmund Christobel Shaw"), "Grand_Cayman_townhall", "sit", "sit2");
			LAi_SetHuberType(characterfromID("Edmund Christobel Shaw"));
			Group_SetAddressNone("FlyingDutchman");
		break;

		case "beaufinal":
			if(AUTO_SKILL_SYSTEM)
			{
				AddPartyExpChar(pchar, "Leadership", 25000);
				AddPartyExpChar(pchar, "Sneak", 200);
			}
			else { AddPartyExp(pchar, 25000); }

			bSuppressResurrection = false;
			AddMoneyToCharacter(pchar, 40000);
			AddQuestRecord("Contact", 8);
			CloseQuestHeader("Contact");
		break;


///////////////////////////////////////////////////////////////
// FIND THE MISSING SON OF THE SPANISH ADMIRAL (Lucas Da Saldanha quest)
///////////////////////////////////////////////////////////////


		case "Luc_start":
			SetEnterLocationQuest("Muelle_residence", "Luc_start_check", 0);
		break;

		case "Luc_start_check":
			if(makeint(PChar.rank) >= 4)
			{
				ChangeCharacterAddressGroup(CharacterFromID("Joaquin Da Saldanha"), "Muelle_Residence", "goto", "goto6");
			}
		break;

		case "Lucas_search_refused":
			PChar.quest.Lucas = "refused";

			DeleteEnterLocationQuest("Muelle_residence", "Luc_start_check");
		break;

		case "Lucas_search_start":
			PChar.quest.Lucas = "search";

			DeleteEnterLocationQuest("Muelle_residence", "Luc_start_check");

			//JOURNAL
			SetQuestHeader("Lucas");
			AddQuestRecord("Lucas", 1);
		break;

		case "Lucas_search1":
			PChar.quest.Lucas = "search1";

			ChangeCharacterAddressGroup(CharacterFromID("Arabella Silehard"), "Redmond_jungle_01", "goto", "goto9");
			ChangeCharacterAddressGroup(CharacterFromID("Arabella's guard 1"), "Redmond_jungle_01", "goto", "goto10");
			ChangeCharacterAddressGroup(CharacterFromID("Arabella's guard 2"), "Redmond_jungle_01", "goto", "goto11");
			LAi_group_MoveCharacter(CharacterFromID("Arabella Silehard"), "ARABELLA");
			LAi_group_MoveCharacter(CharacterFromID("Arabella's guard 1"), "ARABELLA");
			LAi_group_MoveCharacter(CharacterFromID("Arabella's guard 2"), "ARABELLA");
			LAi_SetImmortal(CharacterFromID("Arabella Silehard"), true);
			LAi_SetImmortal(CharacterFromID("Arabella's guard 1"), true);
			LAi_SetImmortal(CharacterFromID("Arabella's guard 2"), true);
			LAi_group_SetRelation("ARABELLA", "ARABELLA", LAI_GROUP_FRIEND);
			LAi_group_SetAlarmReaction("ARABELLA", LAI_GROUP_PLAYER, LAI_GROUP_NEITRAL, LAI_GROUP_NEITRAL);

			//JOURNAL
			AddQuestRecord("Lucas", 2);
		break;

		case "Lucas_search2":
			PChar.quest.Lucas = "search2";

			//JOURNAL
			AddQuestRecord("Lucas", 3);
		break;

		case "Lucas_ransom_refused":
			StartQuestMovie(true, false, false);TrackQuestMovie("start","Lucas_ransom_refused");
			bDisableFastReload = 1;

			LAi_SetActorType(CharacterFromID("Joaquin Da Saldanha"));
			LAi_CharacterDisableDialog(CharacterFromID("Joaquin Da Saldanha"));
			LAi_ActorGoToLocation(CharacterFromID("Joaquin Da Saldanha"), "reload", "reload1", "none", "", "", "Lucas_ransom_refused1", 3.0);

			//JOURNAL
			AddQuestRecord("Lucas", 4);
			CloseQuestHeader("Lucas");
		break;

		case "Lucas_ransom_refused1":
			EndQuestMovie();TrackQuestMovie("end","Lucas_ransom_refused1");
			bDisableFastReload = 0;
		break;

		case "Lucas_ransom_start":
			PChar.quest.Lucas = "ransom";

			AddMoneyToCharacter(PChar, 20000);

			ChangeCharacterAddressGroup(CharacterFromID("Billy Brock"), "Falaise_de_fleur_tavern", "goto", "goto3");
			ChangeCharacterAddressGroup(CharacterFromID("Snorri Baldursson"), "Falaise_de_fleur_tavern", "goto", "goto2");
			ChangeCharacterAddressGroup(CharacterFromID("Francis Snake"), "Ransom_house_f2", "goto", "goto1");
			ChangeCharacterAddressGroup(CharacterFromID("Lucas Da Saldanha"), "Ransom_house_f2", "goto", "goto4");
			Locations[FindLocation("Falaise_De_Fleur_location_03")].reload.l12.close_for_night = 0;
			Locations[FindLocation("Falaise_De_Fleur_location_03")].reload.l12.label = "Kidnappers' Hideout";
			Locations[FindLocation("Falaise_de_fleur_tavern")].vcskip = true; // NK

			PChar.quest.Lucas_ransom_deadline.win_condition.l1 = "Timer";
			PChar.quest.Lucas_ransom_deadline.win_condition.l1.date.day = GetAddingDataDay(0, 1, 0);
			PChar.quest.Lucas_ransom_deadline.win_condition.l1.date.month = GetAddingDataMonth(0, 1, 0);
			PChar.quest.Lucas_ransom_deadline.win_condition.l1.date.year = GetAddingDataYear(0, 1, 0);
			PChar.quest.Lucas_ransom_deadline.win_condition = "Lucas_ransom_deadline";

			PChar.quest.Lucas_ransom_delivery.win_condition.l1 = "location";
			PChar.quest.Lucas_ransom_delivery.win_condition.l1.character = PChar.id;
			PChar.quest.Lucas_ransom_delivery.win_condition.l1.location = "Falaise_de_fleur_tavern";
			PChar.quest.Lucas_ransom_delivery.win_condition = "Lucas_ransom_delivery";

			//JOURNAL
			AddQuestRecord("Lucas", 5);
		break;

		case "Lucas_ransom_deadline":
			DisableFastTravel(false);
			DisableMenuLaunch(false);
			// unneeded if(GetRMRelation(GetMainCharacter(), SPAIN) > REL_AFTERATTACK) SetRMRelation(GetMainCharacter(), SPAIN, REL_AFTERATTACK); // RM - SetNationRelation2MainCharacter(SPAIN, RELATION_ENEMY);
			LeaveService(PChar, SPAIN, false); // RM

			ChangeCharacterAddressGroup(CharacterFromID("Joaquin Da Saldanha"), "none", "", "");
			ChangeCharacterAddressGroup(CharacterFromID("Arabella Silehard"), "none", "", "");
			ChangeCharacterAddressGroup(CharacterFromID("Arabella's guard 1"), "none", "", "");
			ChangeCharacterAddressGroup(CharacterFromID("Arabella's guard 2"), "none", "", "");
			ChangeCharacterAddressGroup(CharacterFromID("Billy Brock"), "none", "", "");
			ChangeCharacterAddressGroup(CharacterFromID("Snorri Baldursson"), "none", "", "");
			ChangeCharacterAddressGroup(CharacterFromID("Francis Snake"), "none", "", "");
			ChangeCharacterAddressGroup(CharacterFromID("Lucas Da Saldanha"), "none", "", "");

			//JOURNAL
			AddQuestRecord("Lucas", 14);
			CloseQuestHeader("Lucas");
		break;

		case "Lucas_ransom_delivery":
			StartQuestMovie(true, false, false);TrackQuestMovie("start","Lucas_ransom_delivery");
			bDisableFastReload = 1;

			LAi_SetActorType(CharacterFromID("Billy Brock"));
			LAi_SetActorType(CharacterFromID("Snorri Baldursson"));

			LAi_ActorTurnToCharacter(CharacterFromID("Billy Brock"), CharacterFromID("Snorri Baldursson"));
			LAi_ActorTurnToCharacter(CharacterFromID("Snorri Baldursson"), CharacterFromID("Billy Brock"));

			LAi_SetActorType(PChar);
			pchar.dialog.currentnode = "Lucas"; // CTM
			LAi_ActorSelfDialog(PChar, "");
		break;

		case "Lucas_ransom_delivery1":
		//dialog exit from self
			LAi_ActorGoToLocator(PChar, "goto", "goto6", "Lucas_ransom_delivery2", 3.0);
		break;

		case "Lucas_ransom_delivery2":
			Pchar.dialog.CurrentNode = "Eavesdrop1";
			LAi_ActorTurnToCharacter(PChar, CharacterFromID("Billy Brock"));
			LAi_ActorSelfDialog(PChar, "");
		break;

		case "Lucas_sign1":
		//dialog exit from Self
			PChar.quest.Lucas = "sign";
			LAi_SetPlayerType(PChar);
			LAi_ActorDialog(CharacterFromID("Billy Brock"), PChar, "", 4.0, -1);
		break;

		case "Lucas_sign2":
		//dialog exit from Brock
			LAi_ActorGoToLocation(CharacterFromID("Billy Brock"), "reload", "reload1", "Falaise_de_fleur_location_03", "goto", "sitizen04", "Lucas_sign3", 5.0);
		break;

		case "Lucas_sign3":
			EndQuestMovie();TrackQuestMovie("end","Lucas_sign3");
			PChar.quest.Lucas_sign4.win_condition.l1 = "location";
			PChar.quest.Lucas_sign4.win_condition.l1.character = PChar.id;
			PChar.quest.Lucas_sign4.win_condition.l1.location = "Falaise_de_fleur_location_03";
			PChar.quest.Lucas_sign4.win_condition = "Lucas_sign4";
		break;

		case "Lucas_sign4":
			StartQuestMovie(true, false, false);TrackQuestMovie("start","Lucas_sign4");
			LAi_ActorGoToLocation(CharacterFromID("Billy Brock"), "reload", "home7", "Ransom_house_f1", "goto", "goto3", "Lucas_sign5", 10.0);
		break;

		case "Lucas_sign5":
			EndQuestMovie();TrackQuestMovie("end","Lucas_sign5");
			bDisableFastReload = 0;
			PChar.quest.Lucas_sign6.win_condition.l1 = "location";
			PChar.quest.Lucas_sign6.win_condition.l1.character = PChar.id;
			PChar.quest.Lucas_sign6.win_condition.l1.location = "Ransom_house_f1";
			PChar.quest.Lucas_sign6.win_condition = "Lucas_sign6";
			Locations[FindLocation("Ransom_house_f1")].vcskip = true; // NK
		break;

		case "Lucas_sign6":
			StartQuestMovie(true, false, false);TrackQuestMovie("start","Lucas_sign6");
			bDisableFastReload = 1;
			LAi_LocationFightDisable(&Locations[FindLocation("Ransom_house_f1")], 1);
			PChar.quest.Lucas = "sign1";
			LAi_ActorDialog(CharacterFromID("Billy Brock"), PChar, "", 4.0, -1);
		break;

		case "Lucas_sign7":
		//dialog exit from Brock
			PChar.quest.Lucas = "sign2";
			LAi_ActorGoToLocation(CharacterFromID("Billy Brock"), "reload", "reload2", "none", "", "", "Lucas_sign8", 10.0);
		break;

		case "Lucas_sign8":
			LAi_QuestDelay("Lucas_sign9", 3.0);
		break;

		case "Lucas_sign9":
			DeleteAttribute(&Locations[FindLocation("Falaise_de_fleur_tavern")],"vcskip"); // NK
			ChangeCharacterAddressGroup(CharacterFromID("Francis Snake"), "Ransom_house_f1", "reload", "reload2");
			LAi_SetActorType(CharacterFromID("Francis Snake"));
			LAi_ActorGoToLocator(CharacterFromID("Francis Snake"), "goto", "goto2", "Lucas_sign9_1", 10.0);

			LAi_QuestDelay("Lucas_sign10", 2.5);
		break;

		case "Lucas_sign9_1":
			LAi_ActorTurnToCharacter(CharacterFromID("Francis Snake"), PChar);
		break;


		case "Lucas_sign10":
			ChangeCharacterAddressGroup(CharacterFromID("Lucas Da Saldanha"), "Ransom_house_f1", "reload", "reload2");
			LAi_SetActorType(CharacterFromID("Lucas Da Saldanha"));
			LAi_ActorGoToLocator(CharacterFromID("Lucas Da Saldanha"), "goto", "goto1", "Lucas_sign10_1", 10.0);

			LAi_QuestDelay("Lucas_sign11", 2.5);
		break;

		case "Lucas_sign10_1":
			LAi_ActorTurnToCharacter(CharacterFromID("Lucas Da Saldanha"), PChar);
		break;

		case "Lucas_sign11":
			ChangeCharacterAddressGroup(CharacterFromID("Billy Brock"), "Ransom_house_f1", "reload", "reload2");
			LAi_ActorGoToLocator(CharacterFromID("Billy Brock"), "goto", "goto3", "Lucas_sign12", 10.0);
		break;

		case "Lucas_sign12":
			EndQuestMovie();TrackQuestMovie("end","Lucas_sign12");

			LAi_ActorDialog(CharacterFromID("Billy Brock"), PChar, "", 3.0, -1);
			DeleteAttribute(&Locations[FindLocation("Ransom_house_f1")],"vcskip"); // NK
		break;

		case "Lucas_kill":
			StartQuestMovie(true, false, false);TrackQuestMovie("start","Lucas_kill");

			LAi_LocationFightDisable(&Locations[FindLocation("Ransom_house_f1")], 0);

			LAi_KillCharacter(CharacterFromID("Lucas Da Saldanha"));

			LAi_SetWarriorType(CharacterFromID("Billy Brock"));
			LAi_SetWarriorType(CharacterFromID("Francis Snake"));

			LAi_group_MoveCharacter(CharacterFromID("Billy Brock"), "kidnappers");
			LAi_group_MoveCharacter(CharacterFromID("Francis Snake"), "kidnappers");

			LAi_group_FightGroups("kidnappers", LAI_GROUP_PLAYER, 1);

			LAi_group_SetCheck("kidnappers", "Lucas_killed");
		break;

		case "Lucas_killed":
			EndQuestMovie();TrackQuestMovie("end","Lucas_killed");

			DisableFastTravel(true);
			DisableMenuLaunch(true);

			DoQuestCheckDelay("Lucas_ransom_deadline", 3.0);
		break;

		case "Lucas_sign13":
		//dialog exit from Brock
			StartQuestMovie(true, false, false);TrackQuestMovie("start","Lucas_sign13");

			AddMoneyToCharacter(PChar, -20000);
			LAi_type_actor_Reset(CharacterFromID("Billy Brock"));
			LAi_type_actor_Reset(CharacterFromID("Francis Snake"));
			LAi_ActorGoToLocation(CharacterFromID("Billy Brock"), "reload", "reload1", "none", "", "", "", 3.0);
			LAi_ActorGoToLocation(CharacterFromID("Francis Snake"), "reload", "reload1", "none", "", "", "Lucas_talk1", 4.0);
		break;

		case "Lucas_talk1":
			Characters[GetCharacterIndex("Lucas Da Saldanha")].dialog.CurrentNode = "free";
			LAi_type_actor_Reset(CharacterFromID("Lucas Da Saldanha"));
			LAi_ActorDialog(CharacterFromID("Lucas Da Saldanha"), PChar, "", 3.0, -1);
		break;

		case "Lucas_talk1_1":
		//dialog exit from Lucas
			EndQuestMovie();TrackQuestMovie("end","Lucas_talk1_1");

			PChar.quest.Lucas = "return";

			GiveItem2Character(CharacterFromId("Lucas Da Saldanha"), "bladeC6");
			GiveItem2Character(CharacterFromId("Lucas Da Saldanha"),"pistol3");
			EquipCharacterByItem(CharacterFromId("Lucas Da Saldanha"), "bladeC6");
			EquipCharacterByItem(CharacterFromId("Lucas Da Saldanha"), "pistol3");

		     //JRH ammo mod -->
			if (ENABLE_AMMOMOD) {	// LDH change
				TakenItems(CharacterFromId("Lucas Da Saldanha"), "gunpowder", 6);
				TakenItems(CharacterFromId("Lucas Da Saldanha"), "pistolgrapes", 6);
			}
		     //JRH ammo mod <--

			LAi_SetImmortal(CharacterFromID("Lucas Da Saldanha"), 1);

			LAi_ActorFollowEverywhere(CharacterFromID("Lucas Da Saldanha"), "", 0.0);

			PChar.quest.Lucas_talk2.win_condition.l1 = "location";
			PChar.quest.Lucas_talk2.win_condition.l1.character = PChar.id;
			PChar.quest.Lucas_talk2.win_condition.l1.location = "Falaise_de_fleur_location_03";
			PChar.quest.Lucas_talk2.win_condition = "Lucas_talk2";

			//JOURNAL
			AddQuestRecord("Lucas", 7);
		break;

		case "Lucas_talk2":
			StartQuestMovie(true, false, false);TrackQuestMovie("start","Lucas_talk2");

			LAi_LocationFightDisable(&Locations[FindLocation("Ransom_house_f1")], 0);
			Characters[GetCharacterIndex("Lucas Da Saldanha")].dialog.CurrentNode = "free1";

			LAi_ActorDialog(CharacterFromID("Lucas Da Saldanha"), PChar, "", 2.0, -1);
		break;

		case "Lucas_talk2_1":
			EndQuestMovie();TrackQuestMovie("end","Lucas_talk2_1");

			bDisableFastReload = 0;

			LAi_ActorFollowEverywhere(CharacterFromID("Lucas Da Saldanha"), "", 0.0);

			PChar.quest.Lucas_return.win_condition.l1 = "location";
			PChar.quest.Lucas_return.win_condition.l1.character = PChar.id;
			PChar.quest.Lucas_return.win_condition.l1.location = "Muelle_Residence";
			PChar.quest.Lucas_return.win_condition = "Lucas_return";

			PChar.quest.Lucas_ransom_deadline.over = "yes";
		break;

		case "Lucas_return":
			StartQuestMovie(true, false, false);TrackQuestMovie("start","Lucas_return");

			LAi_Type_Actor_Reset(CharacterFromID("Lucas Da Saldanha"));

			LAi_SetActorType(characterFromID("Joaquin Da Saldanha"));

			LAi_SetActorType(PChar);

			LAi_ActorGoToLocator(PChar, "goto", "goto7", "Lucas_return1", 1.0);

			LAi_ActorGoToLocator(CharacterFromID("Lucas Da Saldanha"), "goto", "goto9", "Lucas_return_1", 2.0);

			LAi_SetImmortal(CharacterFromID("Lucas Da Saldanha"), 0);
		break;

		case "Lucas_return_1":
			LAi_ActorTurnToCharacter(CharacterFromID("Joaquin Da Saldanha"), CharacterFromID("Lucas Da Saldanha"));
			LAi_ActorTurnToCharacter(CharacterFromID("Lucas Da Saldanha"), CharacterFromID("Joaquin Da Saldanha"));

			LAi_QuestDelay("Lucas_return1", 1.0);
		break;

		case "Lucas_return1":
			LAi_ActorTurnToCharacter(PChar, CharacterFromID("Joaquin Da Saldanha"));

			LAi_QuestDelay("Lucas_return1_1", 1.0);
		break;

		case "Lucas_return1_1":
		//dialog exit from self
			LAi_SetPlayerType(PChar);

			LAi_ActorDialog(CharacterFromID("Joaquin Da Saldanha"), PChar, "", 2.0, -1);
		break;

		case "Lucas_end":

		//dialog exit from Joaquin
			if(AUTO_SKILL_SYSTEM)
			{
				AddPartyExpChar(pchar, "Leadership", 20000);
				AddPartyExpChar(pchar, "Sneak", 200);
			}
			else { AddPartyExp(pchar, 20000); }
			ChangeCharacterReputation(pchar, 20);
// KK -->
			if (ENABLE_FLAGS == 0) {
				if(GetRMRelation(GetMainCharacter(), SPAIN) < REL_AMNESTY) SetRMRelation(GetMainCharacter(), SPAIN, REL_AMNESTY); // RM - SetNationRelation2MainCharacter(SPAIN, RELATION_FRIEND);
			} else {
				if (GetActualRMRelation(SPAIN) < REL_AMNESTY)
					SetActualRMRelation(SPAIN, REL_AMNESTY);
			}
// <-- KK
			AddMoneyToCharacter(PChar, +10000);

			LAi_CharacterDisableDialog(CharacterFromID("Joaquin Da Saldanha"));
			LAi_Type_Actor_Reset(CharacterFromID("Joaquin Da Saldanha"));
			LAi_ActorGoToLocation(CharacterFromID("Joaquin Da Saldanha"), "reload", "reload1", "none", "", "", "", 3.0);

			Characters[GetCharacterIndex("Lucas Da Saldanha")].dialog.CurrentNode = "join";
			LAi_ActorDialog(CharacterFromID("Lucas Da Saldanha"), PChar, "", 2.0, -1);

			//JOURNAL
			AddQuestRecord("Lucas", 9);
			CloseQuestHeader("Lucas");
		break;

		case "Lucas_join":
		//dialog exit from Lucas

			EndQuestMovie();TrackQuestMovie("end","Lucas_join");

			LAi_Type_Actor_Reset(CharacterFromID("Lucas Da Saldanha"));
			SetOfficersIndex(PChar, 3, GetCharacterIndex("Lucas Da Saldanha")); // NK was -1
		break;

		case "Lucas_no_join":
		//dialog exit from Lucas
			LAi_ActorGoToLocator(CharacterFromID("Lucas Da Saldanha"), "goto", "goto4", "Lucas_no_join1", 3.0);
		break;

		case "Lucas_no_join1":
			EndQuestMovie();TrackQuestMovie("end","Lucas_no_join1");

			ChangeCharacterAddressGroup(CharacterFromID("Lucas Da Saldanha"), "Muelle_Residence", "goto", "goto4");

			Characters[GetCharacterIndex("Lucas Da Saldanha")].dialog.CurrentNode = "join_loop";

			LAi_SetStayType(CharacterFromID("Lucas Da Saldanha"));
		break;



///////////////////////////////////////////////////////////////
// SMUGGLING FOR THOMAS O'REILY
///////////////////////////////////////////////////////////////




		case "thomas_contraband_exit":
			LAi_SetHP(characterFromID("Stephan Bonser"), 80.0, 80.0);
			LAi_SetHP(characterFromID("Oswald Chappel"), 80.0, 80.0);
			LAi_SetHP(characterFromID("Gyles Dubois"), 80.0, 80.0);
			LAi_SetCheckMinHP(characterFromID("Stephan Bonser"), LAi_GetCharacterHP(characterFromID("Stephan Bonser"))-1.0, false, "stephan_bonser_attack"); // KK
			LAi_SetCheckMinHP(characterFromID("Oswald Chappel"), LAi_GetCharacterHP(characterFromID("Oswald Chappel"))-1.0, false, "stephan_bonser_attack"); // KK
			LAi_SetCheckMinHP(characterFromID("Gyles Dubois"), LAi_GetCharacterHP(characterFromID("Gyles Dubois"))-1.0, false, "stephan_bonser_attack"); // KK
			ChangeCharacterAddress(characterFromID("Stephan Bonser"), "Redmond_Shore_02", "goto4");
			ChangeCharacterAddress(characterFromID("Oswald Chappel"), "Redmond_Shore_02", "goto6");
			ChangeCharacterAddress(characterFromID("Gyles Dubois"), "Redmond_Shore_02", "goto5"); 
			SetQuestHeader("Thomas_OReily_contraband");
			AddQuestRecord("Thomas_OReily_contraband", 1);
		break;

		case "thomas_contraband_12_exit":
			AddQuestRecord("Thomas_OReily_contraband", 3);
			AddCharacterGoods(characterFromID("Pirate Captain 04"),GOOD_EBONY,100);
			pchar.quest.thomas_contraband_12_exit_2.win_condition.l1 = "location";
			pchar.quest.thomas_contraband_12_exit_2.win_condition.l1.location = "Redmond";
			pchar.quest.thomas_contraband_12_exit_2.win_condition = "thomas_contraband_12_exit_2";
		break;

		case "thomas_contraband_12_exit_2":
			bQuestDisableMapEnter = true;
			Island_SetReloadEnableGlobal("Redmond", false);

			Group_CreateGroup("Smugglers_squadron2");
			Group_AddCharacter("Smugglers_squadron2", "Pirate Captain 04");
			Group_SetGroupCommander("Smugglers_squadron2", "Pirate Captain 04");

			Group_SetPursuitGroup("Smugglers_squadron2", PLAYER_GROUP);
			Group_SetTaskAttack("Smugglers_squadron2", PLAYER_GROUP);
			Group_SetAddress("Smugglers_squadron2", Characters[GetMainCharacterIndex()].location, "", "");

			SetCharacterRelation(GetCharacterIndex("Pirate Captain 04"),GetMainCharacterIndex(),RELATION_ENEMY);

			UpdateRelations();

			pchar.quest.boarding_smuggler_ship.win_condition.l1 = "Character_Capture";
			pchar.quest.boarding_smuggler_ship.win_condition.l1.character = "Pirate Captain 04";
			pchar.quest.boarding_smuggler_ship.win_condition = "boarding_smuggler_ship";

			pchar.quest.sink_smuggler_ship.win_condition.l1 = "NPC_Death";
			pchar.quest.sink_smuggler_ship.win_condition.l1.character = "Pirate Captain 04";
// KK -->
			pchar.quest.sink_smuggler_ship.win_condition.l2 = "location";
			pchar.quest.sink_smuggler_ship.win_condition.l2.location = PChar.location;
// <-- KK
			pchar.quest.sink_smuggler_ship.win_condition = "sink_smuggler_ship";
		break;

		case "boarding_smuggler_ship":
			bQuestDisableMapEnter = false;
			Island_SetReloadEnableGlobal("Redmond", true);
			characters[GetCharacterIndex("Thomas O'Reily")].quest.contraband = "boarding";
		break;

		case "sink_smuggler_ship":
			bQuestDisableMapEnter = false;
			Island_SetReloadEnableGlobal("Redmond", true);
		break;

		case "stephan_bonser_attack":
			LAi_RemoveCheckMinHP(characterFromID("Stephan Bonser"));
			LAi_RemoveCheckMinHP(characterFromID("Oswald Chappel"));
			LAi_RemoveCheckMinHP(characterFromID("Gyles Dubois"));

			LAi_SetActorType(characterFromID("Stephan Bonser"));
			LAi_SetActorType(characterFromID("Oswald Chappel"));
			LAi_SetActorType(characterFromID("Gyles Dubois"));

			AddQuestRecord("Thomas_OReily_contraband", 2);
			LAi_ActorAttack(characterFromID("stephan bonser"), pchar, "");
			LAi_ActorAttack(characterFromID("Oswald Chappel"), pchar, "");
			LAi_ActorAttack(characterFromID("Gyles Dubois"), pchar, "");
			pchar.quest.exit_from_redmond_shore_02.win_condition.l1 = "location";
			pchar.quest.exit_from_redmond_shore_02.win_condition.l1.location = "Redmond";
			pchar.quest.exit_from_redmond_shore_02.win_condition = "quest_exit_from_redmond_shore_02_complete";
			characters[GetCharacterIndex("Thomas O'Reily")].quest.contraband = "after_fight";
		break;

		case "quest_exit_from_redmond_shore_02_complete":
			Group_CreateGroup("Smugglers_squadron");
			Group_AddCharacter("Smugglers_squadron", "Pirate Captain 01");
			Group_AddCharacter("Smugglers_squadron", "Pirate Captain 02");
			Group_AddCharacter("Smugglers_squadron", "Pirate Captain 03");
			Group_SetGroupCommander("Smugglers_squadron", "Pirate Captain 01");

			Group_SetPursuitGroup("Smugglers_squadron", PLAYER_GROUP);
			Group_SetTaskAttack("Smugglers_squadron", PLAYER_GROUP);
			Group_SetAddress("Smugglers_squadron", Characters[GetMainCharacterIndex()].location, "", "");

			SetCharacterRelation(GetCharacterIndex("Pirate Captain 01"),GetMainCharacterIndex(),RELATION_ENEMY);

			UpdateRelations();
		break;


///////////////////////////////////////////////////////////////
// 
///////////////////////////////////////////////////////////////

		PChar.questnotfound = true; // PB: Testing
	}
}
